#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <asm/io.h>
#include <asm/delay.h>
#include <unistd.h>

/*****************************************************************************/
/* Send a command to the multimediacard.                                     */
/*****************************************************************************/
void cmd(icmd1,icmd2,icmd3,icmd4,icmd5)

int icmd1,icmd2,icmd3,icmd4,icmd5;
{
   int spi();
   int icmd,i,isend,itry,inbyte,junk;

/* store unmodified command number
*/
   icmd=icmd1;
/*   printf("sending cmd %d\n",icmd);*/

/* CMD 1 must be sent multiple times (up to 256), others only once
*/
   if(icmd == 1){
      isend=256;
   }else{
      isend=1;
   }

/* CMD's always have bit 7 set
*/
   icmd1|=64;

/* send command byte and 4 data bytes
*/
   for(i=0;i<isend;i++){
      inbyte=spi(icmd1,0);
      inbyte=spi(icmd2,0);
      inbyte=spi(icmd3,0);
      inbyte=spi(icmd4,0);
      inbyte=spi(icmd5,0);

/* send checksum (always 95H for CMD 0, ignored for other commands)
*/
      inbyte=spi(0x95,0);

/* read up to 8 times for a valid response token (R1)
*/
      for(itry=0;itry<8;itry++){
         inbyte=spi(0xff,0);
         if(inbyte != 255)break;
      }

/* send another 8 bits if CMD 1 so the MMC can finish
*/
      if(icmd == 1)junk=spi(0xff,0);

/* if the command is CMD 1 and we got a 0, break out of loop,
   if the command is CMD 1 and we got a 1 we will keep looping,
   if the command is not a CMD 1 the loop is over anyway
*/
      if(inbyte != 1)break;
   }

/* if last byte read was a zero, got a good response so return
*/
   if(inbyte == 0)return;

/* if this was a CMD 0, 1 is a valid response, go back
*/
   if(icmd == 0 && inbyte == 1)return;

/* if got here, an error occurred, print an error message and exit
*/
   if(inbyte == 255){
      printf("MMC did not respond\n");
      exit(1);
   }
   if((inbyte&0x01) == 1)printf("MMC initialization still in progress\n");
   if((inbyte&0x02) == 2)printf("An erase command was given out of sequence\n");
   if((inbyte&0x04) == 4)printf("%d is an illegal command\n",icmd);
   if((inbyte&0x08) == 8)printf("CRC error\n");
   if((inbyte&0x10) == 16)printf("Erase sequence error\n");
   if((inbyte&0x20) == 32)printf("Address error\n");
   if((inbyte&0x40) == 64)printf("Command parameter out of range\n");
   exit(1);
}
